;;; Copyright © 2022 David Elsing <david.elsing@kit.edu>
;;;
;;; This program is free software; you can redistribute it and/or modify it
;;; under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 3 of the License, or (at
;;; your option) any later version.
;;;
;;; This program is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with This program.  If not, see <http://www.gnu.org/licenses/>.


(define-module (chemistry-channel quantum-chemistry)
  #:use-module (chemistry-channel maths)
  #:use-module ((guix licenses) #:prefix license:)
  #:use-module (guix packages)
  #:use-module (guix git-download)
  #:use-module (guix utils)
  #:use-module (guix build-system cmake)
  #:use-module (guix build-system python)
  #:use-module (gnu packages base)
  #:use-module (gnu packages check)
  #:use-module (gnu packages cmake)
  #:use-module (gnu packages maths)
  #:use-module (gnu packages lisp)
  #:use-module (gnu packages python)
  #:use-module (gnu packages python-science)
  #:use-module (gnu packages python-xyz))

(define-public xcfun
  (package
    (name "xcfun")
    (version "2.1.1")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/dftlibs/xcfun.git")
                    (commit (string-append "v" version))))
              (file-name (git-file-name name version))
              (modules '((guix build utils)))
              (snippet
               '(begin
                  (delete-file-recursively "external")
                  (delete-file-recursively "cmake/autocmake")
                  (delete-file-recursively "cmake/downloaded")
                  (delete-file-recursively "CMakeLists.txt")
                  #t))
              (sha256
               (base32
                "1bj70cnhbh6ziy02x988wwl7cbwaq17ld7qwhswqkgnnx8rpgxid"))))
    (build-system cmake-build-system)
    (native-inputs
     `(("libtaylor" ,libtaylor)
       ("autocmake-src"
        ,(let ((version "1.0.0"))
           (origin
             (method git-fetch)
             (uri (git-reference
                   (url "https://github.com/dev-cafe/autocmake")
                   (commit (string-append "v" version))))
             (file-name (git-file-name name version))
             (modules '((guix build utils)))
             (snippet
              '(begin
                 (delete-file-recursively "autocmake/external")))
             (sha256
              (base32
               "149mxbzdi8gj1m2bhp4qr2n3nfssrqa4nnf5clk5kwc0dc8lwab7")))))
       ("python" ,python)
       ("python-pyyaml" ,python-pyyaml)))
    (arguments
     '(#:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'generate-cmake-file
           (lambda* (#:key inputs outputs #:allow-other-keys)
             (let ((autocmake-path (assoc-ref inputs "autocmake-src")))
               (with-directory-excursion "cmake"
                 (substitute* "autocmake.yml"
                   (("^url_root:.*")
                    (string-append "url_root: "
                                   (string-append autocmake-path "/")
                                   "\n")))
                 (invoke "python3"
                         (string-append autocmake-path "/update.py")
                         "..")))
             #t))
         (add-after 'generate-cmake-file 'set-libtaylor-path
           (lambda* (#:key inputs outputs #:allow-other-keys)
             (substitute* "src/CMakeLists.txt"
               (("\\$\\{PROJECT_SOURCE_DIR\\}/external/upstream/taylor")
                (search-input-directory inputs "include/taylor")))
             #t)))))
    (home-page "https://github.com/dftlibs/xcfun")
    (synopsis "Library of exchange-correlation functionals with
arbitrary-order derivatives for density functional theory")
    (description "@code{XCFun} is a library of exchange-correlation
functionals with automatic differentiation.")
    (license license:mpl2.0)))

;; libcint 5.x will be supported by a future release of PySCF
(define-public libcint4
  (package
    (name "libcint4")
    (version "4.4.6")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/sunqm/libcint")
                    (commit (string-append "v" version))))
              (file-name (git-file-name name version))
              (sha256
               (base32
                "06ngzvmrf5haf4sfk2qyy8j21l4056cn2iiizxjs1cqr2cwjwrbr"))
              (modules '((guix build utils)))
              (snippet
               '(begin
                  ;; Autogenerated code
                  (delete-file-recursively "src/autocode")
                  (delete-file "doc/program_ref.pdf")
                  #t))))
    (build-system cmake-build-system)
    (native-inputs (list clisp python python-numpy))
    (inputs (list openblas))
    (arguments
     '(#:configure-flags
       (list "-DWITH_RANGE_COULOMB=1"
             "-DWITH_CINT2_INTERFACE=1"
             "-DMIN_EXPCUTOFF=20"
             "-DQUICK_TEST=ON"
             "-DENABLE_TEST=ON")
       #:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'autogenerate-integrals
           (lambda _
             (mkdir "src/autocode")
             (with-directory-excursion "scripts"
               (invoke "clisp" "auto_intor.cl")
               (for-each
                (lambda (file)
                  (rename-file file (string-append
                                     "../src/autocode/" (basename file))))
                (find-files "." "\\.c$")))
             #t))
         (add-after 'unpack 'adjust-build-path
           (lambda _
             (display (find-files "testsuite" "\\.py$"))
             (newline)
             (substitute* (find-files "testsuite" "\\.py$")
               (("\\.\\./\\.\\./build") "../../../build")))))))
    (home-page "https://github.com/sunqm/libcint")
    (synopsis "General GTO integrals for quantum chemistry")
    (description "@code{libcint} is a C library (also with a Fortran API) to
evaluate one- and two-electron integrals for Gaussian type functions.")
    (license license:bsd-2)))

(define-public qcint4
  (let ((base libcint4))
    (package/inherit base
      (name "qcint4")
      (source
       (origin
         (inherit (package-source base))
         (uri (git-reference
               (url "https://github.com/sunqm/qcint")
               (commit (string-append "v" (package-version base)))))
         (modules '((guix build utils)))
         (snippet
          '(begin
             ;; Autogenerated code
             (delete-file-recursively "src/autocode")
             #t))
         (sha256
          (base32
           "0az6rjvb05kd2axlbfc41kdcynnqz9vvl6lpi1wgig9y1c1i1ybl"))))
      (arguments
       (substitute-keyword-arguments (package-arguments base)
         ((#:configure-flags base-configure-flags '())
          `(cons "-DBUILD_MARCH_NATIVE=OFF" ,base-configure-flags))
         ((#:tests? #f #f) #f)))
      (home-page "https://github.com/sunqm/qcint")
      (synopsis "General GTO integrals for quantum chemistry (SIMD version for x86_64)")
      (description "@code{qcint} is a version of @code{libcint}, a C library
(also with a Fortran API) to evaluate one- and two-electron integrals for
Gaussian type functions.")
      (license license:gpl3+))))

(define-public python-pyscf
  (package
    (name "python-pyscf")
    (version "2.0.1")
    (source (origin
              (method git-fetch)
              (uri (git-reference
                    (url "https://github.com/pyscf/pyscf")
                    (commit (string-append "v" version))))
              (file-name (git-file-name name version))
              (sha256
               (base32
                "0g5h5wkniypwc826rpbwybfpd31bkd36h3rm0s3xbzx7limf22cz"))))
    (build-system python-build-system)
    (propagated-inputs
     (list python-numpy
           python-scipy
           python-h5py))
    (inputs (list
             (if (target-x86-64?) qcint4 libcint4)
             xcfun
             openblas))
    (native-inputs (list cmake gnu-make python-nose))
    (arguments
     '(#:modules
       ((guix build python-build-system)
        (guix build utils)
        (ice-9 textual-ports))
       ;; TODO: Some tests take a very long time and libxc support is not
       ;; turned on at the moment
       #:tests? #f
       #:phases
       (modify-phases %standard-phases
         (add-after 'unpack 'remove-broken-symlinks
           (lambda _
             (for-each
              (lambda (name)
                (delete-file (string-append "examples/" name)))
              '("mrpt/03-dmrg_nevpt2.py"
                "1-advanced/019-state_average_dmrg_casscf.py"
                "1-advanced/020-dmrg_casscf_nevpt2_for_FeS.py"
                "mcscf/33-make_init_guess/32-dmrg_casscf_nevpt2_for_FeS.py"))
             #t))
         (add-before 'build 'set-cmake-arguments
           (lambda* (#:key inputs outputs target configure-flags #:allow-other-keys)
             ;; Copied from cmake-build-system
             (let* ((out (assoc-ref %outputs "out"))
                    (args `("-DCMAKE_BUILD_TYPE=RelWithDebInfo"
                           ,(string-append "-DCMAKE_INSTALL_PREFIX=" out)
                           ;; ensure that the libraries are installed into /lib
                           "-DCMAKE_INSTALL_LIBDIR=lib"
                           ;; add input libraries to rpath
                           "-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=TRUE"
                           ;; add (other) libraries of the project itself to rpath
                           ,(string-append "-DCMAKE_INSTALL_RPATH=" out "/lib")
                           ;; enable verbose output from builds
                           "-DCMAKE_VERBOSE_MAKEFILE=ON"

                           ;;  Cross-build
                           ,@(if target
                                 (list (string-append "-DCMAKE_C_COMPILER="
                                                      target "-gcc")
                                       (string-append "-DCMAKE_CXX_COMPILER="
                                                      target "-g++")
                                       (if (string-contains target "mingw")
                                           "-DCMAKE_SYSTEM_NAME=Windows"
                                           "-DCMAKE_SYSTEM_NAME=Linux"))
                                 '())
                           "-DENABLE_LIBXC=OFF"
                           "-DBUILD_LIBXC=OFF"
                           "-DBUILD_XCFUN=OFF"
                           "-DBUILD_LIBCINT=OFF")))

               ;; This is passed to 'cmake' in setup.py
               (setenv "CMAKE_CONFIGURE_ARGS" (string-join args)))
             #t))
         (replace 'check
           (lambda* (#:key tests? #:allow-other-keys)
             (when tests?
               (invoke "nosetests" "pyscf" "-v"))
             #t)))))
    (home-page "https://github.com/pyscf/pyscf")
    (synopsis "Python library for quantum chemistry calculations")
    (description "@code{PySCF} (Python-based Simulations of Chemistry
Framework) is a Python library for quantum chemistry calculations and method
development.  Most of the functionality is implemented in Python, while
computationally critical parts are implemented in C.")
    (license license:asl2.0)))

(define-public python-geometric
  (package
    (name "python-geometric")
    (version "0.9.7.2")
    (source (origin
			  (method git-fetch)
			  (uri (git-reference
					(url "https://github.com/leeping/geomeTRIC")
					(commit version)))
			  (file-name (git-file-name name version))
			  (sha256
			   (base32
				"108wfzsljxhrfcwwqqhbfly69v49qxgsaw5ar1kcqjiqrjgaf4gd"))))
    (build-system python-build-system)
	(native-inputs (list python-pytest-cov))
	(propagated-inputs
	 (list python-numpy python-scipy python-networkx))
	(arguments
	 '(#:phases
	   (modify-phases %standard-phases
		 (replace 'check
		   (lambda* (#:key tests? inputs outputs #:allow-other-keys)
			 (when tests?
			   (add-installed-pythonpath inputs outputs)
			   (invoke "pytest" "--cov=geometric"))
			 #t)))))
	(home-page "https://github.com/leeping/geomeTRIC")
    (synopsis "Geometry optimization of molecular structures")
    (description "@code{geomeTRIC} is a python library and program
for geometry optimization of molecular structures, which works with
different external quantum chemistry (and molecular mechanics)
softwares.")
    (license license:bsd-3)))

(define-public python-pyscf-properties
  (let ((commit "92a4df7645033349232c4776355f8e53a9256987")
		(revision "0"))
	(package
     (name "python-pyscf-properties")
	 (version (git-version "0.1" revision commit))
	 (source (origin
			  (method git-fetch)
			  (uri (git-reference
					(url "https://github.com/pyscf/properties")
					(commit commit)))
			  (file-name (git-file-name name version))
			  (sha256
			   (base32
				"1fja7vmqs04ia7fv9jrka29r4jkpbsp0cg4z4b9cln90zra3j6fg"))))
     (build-system python-build-system)
	 (propagated-inputs
	  (list python-pyscf))

	 (home-page "https://github.com/pyscf/properties")
     (synopsis "PySCF electronic properties extension")
     (description "")
     (license license:asl2.0))))
